#!/usr/bin/php -q
<?php

DEFINE('SLEEP_PERIOD',1);

/*
 * this script retrieves snmp values using cacti's built-in function
 */

if (!isset($_SERVER['argc']) || $_SERVER['argc']<5) {
    die("error: not enough arguments!\nusage: traffic.php \"command\"\n");
}

chdir(dirname(__FILE__));
chdir("../..");

if (file_exists("./include/global.php")) {
    @include("./include/global.php");
    $V="0.8.7";
} else {
    @include("./include/config.php");
    $V="0.8.6";
}

@include("./lib/snmp.php");
@include("./plugins/zond/zond_functions.php");

global $snmp_details;
$auth=explode("::",$_SERVER['argv'][2]);

$snmp_details['hostname']=$_SERVER['argv'][1];

$snmp_details['version']=$auth[0];
$snmp_details['community']=$auth[1];
$snmp_details['username']=$auth[2];
$snmp_details['password']=$auth[3];
if ($V=="0.8.7") 
    $snmp_details['auth_proto']=$auth[4];
if ($V=="0.8.7") 
    $snmp_details['priv_pass']=$auth[5];
if ($V=="0.8.7") 
    $snmp_details['priv_proto']=$auth[6];
if ($V=="0.8.7") 
    $snmp_details['context']=$auth[7];
$snmp_details['port']=($V=="0.8.7") ? $auth[8] : $auth[4];
$snmp_details['timeout']=($V=="0.8.7") ? $auth[9] : $auth[5];

$oid=$_SERVER['argv'][3];
$TYPE=$_SERVER['argv'][4];

if ($TYPE == 1) {       //gauge
    echo snmp_data($oid);
} else {                //counter
    $counter['prev'] = snmp_data($oid);

    $timePrev=time() + microtime();
        sleep(SLEEP_PERIOD);
    $delta_t=time() + microtime() - $timePrev;

    $counter['curr'] = snmp_data($oid);
    
    if ($counter['curr']=="NaN" || $counter['prev']=="NaN")
	echo "NaN";
    else
	echo round(($counter['curr'][0] - $counter['prev'][0]) / ($counter['prev'][1]/2+$counter['curr'][1]/2+$delta_t),2)."\n";
//echo $counter['curr'][0]." - ".$counter['prev'][0]." / ".($counter['prev'][1]/2+$counter['curr'][1]/2+$delta_t)."\n";
}
?>
