<?php

/*
 * ZOND plugin data gathering for the java-applet
 * by johnrembo@netzond.com
 */

chdir(dirname(__FILE__));
chdir("../..");

if (file_exists("./include/global.php")) {
    @include("./include/global.php");
    $V="0.8.7";
} else {
    @include("./include/config.php");
    $V="0.8.6";
}

@include_once("./lib/utility.php");
@include_once("./lib/rrd.php");
@include_once("./lib/api_graph.php");
@include_once("./lib/api_tree.php");
@include_once("./lib/api_data_source.php");
@include_once("./lib/template.php");
@include_once("./lib/html_tree.php");
@include_once("./lib/html_form_template.php");
@include_once("./lib/data_query.php");
@include_once("./lib/cdef.php");
@include_once("./plugins/zond/rpn_calc.php");
@include_once("./plugins/zond/zond_functions.php");

foreach ($zond_config_params as $zcp) {
    eval("\$$zcp=read_config_option('zond_$zcp');");
}

//some security operations
if (count($_REQUEST)>0) {
    $tasks = get_request_var("tasks");
    $s_i_d = get_request_var("s_i_d");
    if ( $security=='0' && $s_i_d != '' && check_string($s_i_d) ) {
        ini_set("session.auto_start",0);
        @session_write_close();
        @session_id($s_i_d);
        @session_start();
        if (!isset($_SESSION['sess_user_id'])) {
            cacti_log("ERROR: User not authorised for session id (".session_id().") received from ".$_SERVER['REMOTE_ADDR'], false, "ZOND");
            die("Non-existing session id!\n");
        }
    }
    if ( $security == '1' && (!isset($_SERVER['HTTP_USER_AGENT']) || !stristr($_SERVER['HTTP_USER_AGENT'],'java')) ) {
        cacti_log("ERROR: Current configuration does not allow direct access to ZOND for <a title=\"".$_SERVER['HTTP_USER_AGENT']."\">application</a> from location from ".$_SERVER['REMOTE_ADDR'], false, "ZOND");
	header("Location:../index.php");
	die;
    }
} else if (isset($_SERVER['argc']) && $_SERVER['argc']>1) {
    check_string($_SERVER['argv'][1]);
    $tasks = $_SERVER['argv'][1];
} else {
    die ("not enough parrameters!\n");
}

if ($hashed=='0')
    $tasks = scatter($tasks,$hash,adopt_hbs(strlen($tasks),$hash_blck_size[$hash_blcksize]),false);

//decodes data
$req = unserialize(decode_base64($tasks));
//print_r($req);//die;

$previous = '';
$multi_record_script = false;

//launches data collecting
foreach ($req['MAP'] as $id => $val) {
    if ( !isset($req[$id]['query']) ) 
	continue;
    
    if ( isset($req[$id]['match']) && ($req[$id]['query'] == $previous) ) {
	$multi_record_script = true;
	continue;
    }
    
    if ($req[$id]['method'] != 0) {			//fork command
	if ($req[$id]['type'] == 1) {			//script output is GAUGE
	    if ($req[$id]['method'] == 1) {		//shell command 
		if (stristr($req[$id]['query'],'.php') && !stristr($req[$id]['query'],$php_bin_path) )
		    $req[$id]['query'] = "$php_bin_path -q".$req[$id]['query'];
    		$fh[$id] = popen($req[$id]['query'],"r");
	    }else{ 					//php script server command
		$tsk = explode(" ",$req[$id]['query']);
		
		if (stristr($tsk[0],$php_bin_path)) {//avoid double /usr/bin/php
		    $ss_task="";
		    $tsk[0] = dequote(str_replace("/php","/php -q",$tsk[0]));//add "-q"
		} else {
		    $ss_task=$php_bin_path." -q";
		}

		if (stristr(dequote($tsk[0]),dequote($tsk[1]))) {//remove function name from SS arguments, if SS_name is equal to function name
		    unset($tsk[1]);
		}
		
		foreach ($tsk as $subt) {
		    if ($subt==$php_bin_path || $subt=="-q") 
			continue;
		    $ss_task.=" ".$subt;
		}
//		echo "executing: $ss_task\n";
		$fh[$id] = popen($ss_task,"r");
	    }
	} else {					//script output is COUNTER
	    $fh[$id] = popen("$php_bin_path -q ./plugins/zond/traffic.php \"".str_replace('$','\$',$req[$id]['query'])."\"","r");
	}
    } else {						//fork snmp-get (query allready contains counter/gauge descriptor, no need to check TYPE)
        $fh[$id] = popen("$php_bin_path -q ./plugins/zond/snmp.php ".$req[$id]['query'],"r");
    }
    
    $previous = $req[$id]['query'];
}

//fetches collected values
foreach ($fh as $id => $value) {
	$output[$id] = '';
	if ($value) {
	    while ($data = fgets($value)) 
		$output[$id] .= $data;
	    pclose($value);
	    $output[$id] = trim($output[$id]);
	}
	
	//saves output values. emtpy values are replaced with zeroes.
	$req['VALS'][ $req['MAP'][$id] ] = ((empty($output[$id]) || $output[$id]=="") ? 0 : $output[$id]);
	
	if ( stristr($output[$id],":") && !($multi_record_script) ) $multi_record_script = true;
}
//print_r($req['VALS']);

//matches collected values
if ($multi_record_script) {
    foreach ($req['VALS'] as $id => $value) {
	if (substr_count($value," ")>0) //if multi-output value found
	    foreach (explode(" ",$value) as $single_output) //split strings into array
	    	foreach ($req as $id2 => $value2) //assing certain values to to apropirate DEFs by checking [match] agains single_output
		if ( isset($value2['match']) && preg_match("/^(".$value2['match']."):([-+]?[0-9]*\.?[0-9]+)$/i",$single_output,$matches) ) {
		    //save matched values
		    $req['VALS'][$req['MAP'][$id2]] = $matches[2];
		    $output[$id2] = $matches[2];
		}
    }
}

//updates $output array with translated id's (for cdef calculation). also creates aditional array containing these values.
foreach ($output as $oid => $oval) {
    $output[$req['MAP'][$oid]]=$oval;
    $pure[$req['MAP'][$oid]]=$oval;
}

//aditional array for index translation
foreach ($req['MAP'] as $mid => $mapM_id) {
    if (stristr($mid,'::'))
	$supermap[$mapM_id]=$mid;
}

//print_r($output);
//upates $output array with all the possible indexes and values
foreach ($req['PRINT'] as $pid => $mapP_id) {//
    if(stristr($mapP_id,'cdef') && !isset($req[$mapP_id])) {//inner cdef(real)
	foreach ($req[$supermap[$req['MAP'][$mapP_id]]]['cdef_string'] as $cdef_name => $cdef_string) {
//	echo "output[$mapP_id]=rpn_calc(str_relpace(\$req['MAP'][$mapP_id],\$output[\$req['MAP'][$mapP_id]], $cdef_string))\n";
	    $output[$mapP_id]=rpn_calc(str_replace($req['MAP'][$mapP_id],$output[$req['MAP'][$mapP_id]], $cdef_string));
	}
    } elseif (stristr($mapP_id,'cdef') && isset($req[$mapP_id])) {//outer cdef(virtual)
    	$output[$mapP_id]=rpn_calc(str_replace(array_keys($pure),array_values($pure), $req[$mapP_id]));
    }
}

//print_r($output);die;
foreach ($req['PRINT'] as $pid => $mapP_id) {
    $results[$pid]=$output[$mapP_id];
}

/*
    this replace eliminates UN problem in the applet (applet can dispaly only digits)
    but it causes problems when UNs appear and dissapear:
    (xxxxxx[current value]-0[UN -previuos value])/time=xxxxxx/time - applet starts dispalying nonsenses (counter instead of gauge etc...)
*/
//echo str_replace( 'UN','0',implode("\n",$results) );
echo implode("\n",$results);

?>
